/* prog.h: structures for the program/shell channel */

/*
 * @(#) $Header: /cs/research/pp/hubris/pp-beta/Chans/shell/RCS/prog.h,v 5.0 90/09/20 15:53:45 pp Exp Locker: pp $
 *
 * $Log:	prog.h,v $
 * Revision 5.0  90/09/20  15:53:45  pp
 * rcsforce : 5.0 public release
 * 
 *
 */



#ifndef _H_SHELL_PROG
#define _H_SHELL_PROG


#include <pwd.h>

typedef struct prog_struct {
	unsigned int		timeout_in_secs;	/* in seconds */
	char			*cmd_line;
	int			uid;
	int			gid;

	char			*username;
	char			*home;
	char			*shell;
}  ProgInfo;


#define NULLPROG		((ProgInfo *) 0)

ProgInfo			*tb_getprog();
void				prog_free();


#endif
