/* encinfo2rfc.c - Converts a EncodedIT struct into a RFC string */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/encinfo2rfc.c,v 5.0 90/09/20 16:04:53 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/encinfo2rfc.c,v 5.0 90/09/20 16:04:53 pp Exp Locker: pp $
 *
 * $Log:	encinfo2rfc.c,v $
 * Revision 5.0  90/09/20  16:04:53  pp
 * rcsforce : 5.0 public release
 * 
 */



#include                "util.h"
#include                <isode/cmd_srch.h>
#include                "mta.h"
#include                "tb_bpt84.h"

extern CMD_TABLE        bptbl_body_parts84 [/* body part types */];



/* ---------------------  Begin  Routines  -------------------------------- */


extern char	*hdr_822_bp,
		*hdr_p2_bp;

void encinfo2rfc (eit, buffer)  /* EncodedInformationTypes -> RFC */
EncodedIT       *eit;
char            *buffer;
{
	LIST_BPT        *list;
	char            tbuf[LINESIZE],
			*odif, *undef, *value;
	int             comma=FALSE;

	bzero (&tbuf[0], LINESIZE);
	odif  = rcmd_srch (BPT_ODIF, bptbl_body_parts84);
	undef = rcmd_srch (BPT_UNDEFINED, bptbl_body_parts84);

	for (list = eit->eit_types; list; list = list->li_next) {
		value = list -> li_name;
		if (strncmp (hdr_822_bp, value, strlen(hdr_822_bp)) == 0)
			continue;
		if (strncmp (hdr_p2_bp, value, strlen(hdr_p2_bp)) == 0)
			continue;
		if (strncmp ("delivery.", value, 9) == 0)
			continue;
		if (lexequ (value, odif) == 0)
			value = undef;
		if (comma)
			(void) strcat (&tbuf[0], ", ");
		else
			comma = TRUE;
		(void) strcat (&tbuf[0], value);
	}

	(void) strcpy (buffer, tbuf);

	PP_DBG (("Lib/encinfo2rfc returns (%s)", buffer));

	return;
}
